Package: org.grails.gsp.compiler

## [Java] Class GroovyPageParser

- org.grails.gsp.compiler.GroovyPageParser

- All Implemented Interfaces and Traits:
    Tokens

      public class GroovyPageParser
      extends java.lang.Object

  NOTE: Based on work done by the GSP standalone project (https://gsp.dev.java.net/). Parsing implementation for GSP files

  Authors:
    Troy Heninger
    Graeme Rocher
    Lari Hotari

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static java.lang.String` | `CODEC_DIRECTIVE_POSTFIX` |
    `static java.lang.String` | `CONFIG_PROPERTY_DEFAULT_CODEC` |
    `static java.lang.String` | `CONFIG_PROPERTY_GSP_CODECS` |
    `static java.lang.String` | `CONFIG_PROPERTY_GSP_ENCODING` |
    `static java.lang.String` | `CONFIG_PROPERTY_GSP_KEEPGENERATED_DIR` |
    `static java.lang.String` | `CONFIG_PROPERTY_GSP_SITEMESH_PREPROCESS` |
    `static java.lang.String` | `CONSTANT_NAME_CONTENT_TYPE` |
    `static java.lang.String` | `CONSTANT_NAME_EXPRESSION_CODEC` |
    `static java.lang.String` | `CONSTANT_NAME_JSP_TAGS` |
    `static java.lang.String` | `CONSTANT_NAME_LAST_MODIFIED` |
    `static java.lang.String` | `CONSTANT_NAME_OUT_CODEC` |
    `static java.lang.String` | `CONSTANT_NAME_STATIC_CODEC` |
    `static java.lang.String` | `CONSTANT_NAME_TAGLIB_CODEC` |
    `static java.lang.String` | `DEFAULT_ENCODING` |
    `static java.lang.String[]` | `DEFAULT_IMPORTS` |
    `static java.lang.String` | `GROOVY_SOURCE_CHAR_ENCODING` |
    `static org.apache.commons.logging.Log` | `LOG` |

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `java.lang.Object` | `GroovyPageParser(java.lang.String name, java.lang.String uri, java.lang.String filename, java.io.InputStream in, java.lang.String encoding, java.lang.String expressionCodecName)`
    `` | `java.lang.Object` | `GroovyPageParser(java.lang.String name, java.lang.String uri, java.lang.String filename, java.lang.String gspSource)`
    `` | `java.lang.Object` | `GroovyPageParser(java.lang.String name, java.lang.String uri, java.lang.String filename, java.lang.String gspSource, java.lang.String expressionCodecName)`
    `` | `java.lang.Object` | `GroovyPageParser(java.lang.String name, java.lang.String uri, java.lang.String filename, java.io.InputStream in)`
    `` | `void` | `configure(ConfigMap config)` Configures the parser for the given Config map
    `` | `void` | `flushTagBuffering()`
    `` | `void` | `generateGsp(java.io.Writer target)`
    `` | `void` | `generateGsp(java.io.Writer target, boolean precompileMode)`
    `` | `java.lang.String` | `getClassName()`
    `` | `java.lang.String` | `getContentType()`
    `` | `int` | `getCurrentOutputLineNumber()`
    `` | `java.lang.String` | `getExpressionCodecDirectiveValue()`
    `` | `java.lang.String` | `getExpressionText(java.lang.String text)` Returns an expression text for the given expression
    `` | `java.lang.String` | `getExpressionText(java.lang.String text, boolean _safeDereference)`
    `` | `static java.lang.String` | `getGspEncoding()`
    `` | `java.util.List<java.lang.String>` | `getHtmlParts()`
    `` | `java.lang.String[]` | `getHtmlPartsArray()`
    `` | `java.util.Map<java.lang.String, java.lang.String>` | `getJspTags()`
    `` | `long` | `getLastModified()`
    `` | `int[]` | `getLineNumberMatrix()`
    `` | `java.lang.String` | `getOutCodecDirectiveValue()`
    `` | `java.lang.String` | `getPackageName()`
    `` | `java.lang.String` | `getPageName()`
    `` | `java.lang.String` | `getStaticCodecDirectiveValue()`
    `` | `java.lang.String` | `getTaglibCodecDirectiveValue()`
    `` | `boolean` | `isInClosure()`
    `` | `java.io.InputStream` | `parse()`
    `` | `void` | `setClassName(java.lang.String className)`
    `` | `void` | `setEnableSitemeshPreprocessing(boolean enableSitemeshPreprocessing)`
    `` | `void` | `setExpressionCodecDirectiveValue(java.lang.String expressionCodecDirectiveValue)`
    `` | `void` | `setKeepGeneratedDirectory(java.io.File keepGeneratedDirectory)`
    `` | `void` | `setLastModified(long lastModified)`
    `` | `void` | `setOutCodecDirectiveValue(java.lang.String outCodecDirectiveValue)`
    `` | `void` | `setPackageName(java.lang.String packageName)`
    `` | `void` | `setStaticCodecDirectiveValue(java.lang.String staticCodecDirectiveValue)`
    `` | `void` | `setTaglibCodecDirectiveValue(java.lang.String taglibCodecDirectiveValue)`
    `` | `void` | `writeHtmlParts(java.io.File filename)`
    `` | `void` | `writeLineNumbers(java.io.File filename)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Field Detail

    - #### public static final java.lang.String CODEC_DIRECTIVE_POSTFIX

    - #### public static final java.lang.String CONFIG_PROPERTY_DEFAULT_CODEC

    - #### public static final java.lang.String CONFIG_PROPERTY_GSP_CODECS

    - #### public static final java.lang.String CONFIG_PROPERTY_GSP_ENCODING

    - #### public static final java.lang.String CONFIG_PROPERTY_GSP_KEEPGENERATED_DIR

    - #### public static final java.lang.String CONFIG_PROPERTY_GSP_SITEMESH_PREPROCESS

    - #### public static final java.lang.String CONSTANT_NAME_CONTENT_TYPE

    - #### public static final java.lang.String CONSTANT_NAME_EXPRESSION_CODEC

    - #### public static final java.lang.String CONSTANT_NAME_JSP_TAGS

    - #### public static final java.lang.String CONSTANT_NAME_LAST_MODIFIED

    - #### public static final java.lang.String CONSTANT_NAME_OUT_CODEC

    - #### public static final java.lang.String CONSTANT_NAME_STATIC_CODEC

    - #### public static final java.lang.String CONSTANT_NAME_TAGLIB_CODEC

    - #### public static final java.lang.String DEFAULT_ENCODING

    - #### public static final java.lang.String[] DEFAULT_IMPORTS

    - #### public static final java.lang.String GROOVY_SOURCE_CHAR_ENCODING

    - #### public static final org.apache.commons.logging.Log LOG

  - ### Method Detail

    - #### public java.lang.Object GroovyPageParser(java.lang.String name, java.lang.String uri, java.lang.String filename, java.io.InputStream in, java.lang.String encoding, java.lang.String expressionCodecName)

    - #### public java.lang.Object GroovyPageParser(java.lang.String name, java.lang.String uri, java.lang.String filename, java.lang.String gspSource)

    - #### public java.lang.Object GroovyPageParser(java.lang.String name, java.lang.String uri, java.lang.String filename, java.lang.String gspSource, java.lang.String expressionCodecName)

    - #### public java.lang.Object GroovyPageParser(java.lang.String name, java.lang.String uri, java.lang.String filename, java.io.InputStream in)

    - #### public void configure(ConfigMap config)

      Configures the parser for the given Config map

      Parameters:
        `config` - The config map

    - #### public void flushTagBuffering()

    - #### public void generateGsp(java.io.Writer target)

    - #### public void generateGsp(java.io.Writer target, boolean precompileMode)

    - #### public java.lang.String getClassName()

    - #### public java.lang.String getContentType()

    - #### public int getCurrentOutputLineNumber()

    - #### public java.lang.String getExpressionCodecDirectiveValue()

    - #### public java.lang.String getExpressionText(java.lang.String text)

      Returns an expression text for the given expression

      Parameters:
        `text` - The text
      Returns:
        An expression text

    - #### public java.lang.String getExpressionText(java.lang.String text, boolean _safeDereference)

    - #### public static java.lang.String getGspEncoding()

    - #### public java.util.List<java.lang.String> getHtmlParts()

    - #### public java.lang.String[] getHtmlPartsArray()

    - #### public java.util.Map<java.lang.String, java.lang.String> getJspTags()

    - #### public long getLastModified()

    - #### public int[] getLineNumberMatrix()

    - #### public java.lang.String getOutCodecDirectiveValue()

    - #### public java.lang.String getPackageName()

    - #### public java.lang.String getPageName()

    - #### public java.lang.String getStaticCodecDirectiveValue()

    - #### public java.lang.String getTaglibCodecDirectiveValue()

    - #### public boolean isInClosure()

    - #### public java.io.InputStream parse()

    - #### public void setClassName(java.lang.String className)

    - #### public void setEnableSitemeshPreprocessing(boolean enableSitemeshPreprocessing)

    - #### public void setExpressionCodecDirectiveValue(java.lang.String expressionCodecDirectiveValue)

    - #### public void setKeepGeneratedDirectory(java.io.File keepGeneratedDirectory)

    - #### public void setLastModified(long lastModified)

    - #### public void setOutCodecDirectiveValue(java.lang.String outCodecDirectiveValue)

    - #### public void setPackageName(java.lang.String packageName)

    - #### public void setStaticCodecDirectiveValue(java.lang.String staticCodecDirectiveValue)

    - #### public void setTaglibCodecDirectiveValue(java.lang.String taglibCodecDirectiveValue)

    - #### public void writeHtmlParts(java.io.File filename)

    - #### public void writeLineNumbers(java.io.File filename)